
//+------------------------------------------------------------------+
//|                                                   Piligrimus.mq4 |
//|                                    Copyright  2009, K.Piligrimm |
//|                                             piligrimm_fx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, K.Piligrimm"
#property link      "mailto: piligrimm_fx@mail.ru"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 DarkViolet
#property indicator_color4 Red
#property indicator_color5 Magenta
#property indicator_color6 Blue
#property indicator_color7 Pink
#property indicator_color8 Tomato

//---- input parameters
        
double GR1[],GR2[],GR3[],GR4[],GR5[],GR6[],GR7[],GR8[];
double ZZ[],ZX[],ZC[],ZV[],ZB[],ZA[],ZS[],ZD[],XX[],XN[],XM[];
int i;
extern int LengthSample=1000;
extern double Kn=1;
//---- buffers

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,GR1);
   SetIndexBuffer(1,GR2);
   SetIndexBuffer(2,GR3);
   SetIndexBuffer(3,GR4);
   SetIndexBuffer(4,GR5);
   SetIndexBuffer(5,GR6);
   SetIndexBuffer(6,GR7);
   SetIndexBuffer(7,GR8);
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1, DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(2, DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(3, DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(4, DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(5, DRAW_LINE,STYLE_SOLID,3);
   SetIndexStyle(6, DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(7, DRAW_LINE,STYLE_SOLID,3);
   ArrayResize(GR1, LengthSample-20);
   ArrayResize(GR2, LengthSample-20);
   ArrayResize(GR3, LengthSample-20);
   ArrayResize(GR4, LengthSample-20);
   ArrayResize(GR5, LengthSample-20);
   ArrayResize(GR6, LengthSample-20);
   ArrayResize(GR7, LengthSample-20);
   ArrayResize(GR8, LengthSample-20); 
   ArrayResize(XX, LengthSample+1);
   ArrayResize(XN, LengthSample+1);
   ArrayResize(XM, LengthSample+1);
   ArrayResize(ZZ, LengthSample+1);
   ArrayResize(ZX, LengthSample+1);
   ArrayResize(ZC, LengthSample+1);
   ArrayResize(ZV, LengthSample+1);
   ArrayResize(ZB, LengthSample+1);
   ArrayResize(ZA, LengthSample+1);
   ArrayResize(ZS, LengthSample+1);
   ArrayResize(ZD, LengthSample+1);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
    {//1

   for (i = LengthSample-1; i>=0; i--)
       ZS[i] = 0.7*(0.5*(0.7*(0.6*(0.7*(0.7*(0.107833 *(Open[i+4] -(Open[i+4] - Close[i+4])/2)+0.340401 *(Open[i+11] -(Open[i+11] - Close[i+11])/2)
               +0.736267 *(Open[i+2] -(Open[i+2] - Close[i+2])/2)+0.142477 *(Open[i+7] -(Open[i+7] - Close[i+7])/2)-0.32699 *(Open[i+2] -(0.5*(Open[i+2] 
               - Low[i+2])/2 - 0.5*(0.55*(High[i+2] - Low[i+2])/2 + 0.45*(Open[i+2] - Close[i+2])/2))))+0.3*((0.000229172 +0.242494*(Open[i] 
               -(-0.55*(High[i] - Low[i])/2 - 0.45*(Open[i] - Close[i])/2)) -0.179288*(Open[i] -(Close[i] - Low[i])/2) +0.936627*(Open[i] -(Open[i] 
               - Low[i])/2)+Close[i])/2)) +0.3*(0.9*(0.0526913 *(Open[i+6] -(Open[i+6] - Close[i+6])/2)+0.340053 *(Open[i+13] -(Open[i+13] 
               - Close[i+13])/2)+0.45855 *(Open[i+4] -(Open[i+4] - Close[i+4])/2)+0.148683 *(Open[i+9] -(Open[i+9] - Close[i+9])/2))
               +0.1*((0.000229172 +0.242494*(Open[i+1] -(-0.55*(High[i+1] - Low[i+1])/2 - 0.45*(Open[i+1] - Close[i+1])/2)) -0.179288*(Open[i+1] 
               -(Close[i+1] - Low[i+1])/2) +0.936627*(Open[i+1] -(Open[i+1] - Low[i+1])/2)+Close[i+1])/2))) +0.4*((0.06662 *(Open[i+5] -(Open[i+5] 
               - Close[i+5])/2)*(Open[i+2] -(Open[i+2] - Close[i+2])/2)+0.399589 *(Open[i+5] -(Open[i+5] - Close[i+5])/2)*(Open[i+9] -(Open[i+9] 
               - Close[i+9])/2)+0.699362 *(Open[i+5] -(Open[i+5] - Close[i+5])/2)*(Open[i] -(Open[i] - Close[i])/2)+0.000683249)/((Open[i+5] 
               -(Open[i+5] - Close[i+5])/2)+0.165956 *(Open[i] -(Open[i] - Close[i])/2)))) +0.3*(0.8*(0.107833 *(Open[i+4] -(Open[i+4] 
               - Close[i+4])/2)+0.340401 *(Open[i+11] -(Open[i+11] - Close[i+11])/2)+0.736267 *(Open[i+2] -(Open[i+2] - Close[i+2])/2)+0.142477 
               *(Open[i+7] -(Open[i+7] - Close[i+7])/2)-0.32699 *(Open[i+2] -(0.5*(Open[i+2] - Low[i+2])/2 - 0.5*(0.55*(High[i+2] - Low[i+2])/2 
               + 0.45*(Open[i+2] - Close[i+2])/2)))) +0.2*((0.000229172 +0.242494*(Open[i] -(-0.55*(High[i] - Low[i])/2 - 0.45*(Open[i] - Close[i])/2)) 
               -0.179288*(Open[i] -(Close[i] - Low[i])/2) +0.936627*(Open[i] -(Open[i] - Low[i])/2)+Close[i])/2))) +0.5*(0.7*(0.6*(0.7*(0.7*(0.107833 
               *(Open[i+4] -(Open[i+4] - Close[i+4])/2)+0.340401 *(Open[i+11] -(Open[i+11] - Close[i+11])/2)+0.736267 *(Open[i+2] -(Open[i+2] 
               - Close[i+2])/2)+0.142477 *(Open[i+7] -(Open[i+7] - Close[i+7])/2)-0.32699 *(Open[i+2] -(0.5*(Open[i+2] - Low[i+2])/2 - 0.5*(0.55
               *(High[i+2] - Low[i+2])/2 + 0.45*(Open[i+2] - Close[i+2])/2)))) +0.3*((0.000229172 +0.242494*(Open[i] -(-0.55*(High[i] - Low[i])/2 
               - 0.45*(Open[i] - Close[i])/2)) -0.179288*(Open[i] -(Close[i] - Low[i])/2) +0.936627*(Open[i] -(Open[i] - Low[i])/2)+Close[i])/2))
               +0.3*(0.9*(0.0526913 *(Open[i+6] -(Open[i+6] - Close[i+6])/2)+0.340053 *(Open[i+13] -(Open[i+13] - Close[i+13])/2)+0.45855 *(Open[i+4] 
               -(Open[i+4] - Close[i+4])/2)+0.148683 *(Open[i+9] -(Open[i+9] - Close[i+9])/2))+0.1*((0.000229172 +0.242494*(Open[i+1] -(-0.55
               *(High[i+1] - Low[i+1])/2 - 0.45*(Open[i+1] - Close[i+1])/2)) -0.179288*(Open[i+1] -(Close[i+1] - Low[i+1])/2) +0.936627*(Open[i+1] 
               -(Open[i+1] - Low[i+1])/2)+Close[i+1])/2))) +0.4*((0.06662 *(Open[i+5] -(Open[i+5] - Close[i+5])/2)*(Open[i+2] -(Open[i+2] - Close[i+2])/2)+0.399589 *(Open[i+5] -(Open[i+5] - Close[i+5])/2)*(Open[i+9] -(Open[i+9] - Close[i+9])/2)+0.699362 *(Open[i+5] -(Open[i+5] - Close[i+5])/2)*(Open[i] -(Open[i] - Close[i])/2)+0.000683249)/((Open[i+5] -(Open[i+5] - Close[i+5])/2)+0.165956 *(Open[i] -(Open[i] - Close[i])/2))))
               +0.3*(0.8*(0.0526913 *(Open[i+5] -(Open[i+5] - Close[i+5])/2)+0.340053 *(Open[i+12] -(Open[i+12] - Close[i+12])/2)+0.45855 *(Open[i+3] 
               -(Open[i+3] - Close[i+3])/2)+0.148683 *(Open[i+8] -(Open[i+8] - Close[i+8])/2)) +0.2*((0.000229172 +0.242494*(Open[i] -(-0.55*(High[i] 
               - Low[i])/2 - 0.45*(Open[i] - Close[i])/2)) -0.179288*(Open[i] -(Close[i] - Low[i])/2) +0.936627*(Open[i] -(Open[i] - Low[i])/2)
               +Close[i])/2)))) +0.3*(0.6*(0.7*((0.0938048 *(Open[i+8] -(Open[i+8] - Close[i+8])/2)*(Open[i+5] -(Open[i+5] - Close[i+5])/2)+0.570724 
               *(Open[i+8] -(Open[i+8] - Close[i+8])/2)*(Open[i+12] -(Open[i+12] - Close[i+12])/2)+0.450638 *(Open[i+8] -(Open[i+8] - Close[i+8])/2)
               *(Open[i+3] -(Open[i+3] - Close[i+3])/2)+0.000484645 -0.288176 *(Open[i+3] -(0.5*(Open[i+3] - Low[i+3])/2 - 0.5*(0.55*(High[i+3] 
               - Low[i+3])/2 + 0.45*(Open[i+3] - Close[i+3])/2)))*(Open[i+12] -(Open[i+12] - Close[i+12])/2))/((Open[i+8] -(Open[i+8] - Close[i+8])/2)
               -0.172744 *(Open[i+3] -(Open[i+3] - Close[i+3])/2)))+0.3*((0.000229172 +0.242494*(Open[i+1] -(-0.55*(High[i+1] - Low[i+1])/2 
               - 0.45*(Open[i+1] - Close[i+1])/2)) -0.179288*(Open[i+1] -(Close[i+1] - Low[i+1])/2) +0.936627*(Open[i+1] -(Open[i+1] - Low[i+1])/2)
               +Close[i+1])/2))+0.4*((0.0938048 *(Open[i+6] -(Open[i+6] - Close[i+6])/2)*(Open[i+3] -(Open[i+3] - Close[i+3])/2)+0.570724 *(Open[i+6] 
               -(Open[i+6] - Close[i+6])/2)*(Open[i+10] -(Open[i+10] - Close[i+10])/2)+0.450638 *(Open[i+6] -(Open[i+6] - Close[i+6])/2)*(Open[i+1] 
               -(Open[i+1] - Close[i+1])/2)+0.000484645 -0.288176 *(Open[i+1] -(0.5*(Open[i+1] - Low[i+1])/2 - 0.5*(0.55*(High[i+1] - Low[i+1])/2 
               + 0.45*(Open[i+1] - Close[i+1])/2)))*(Open[i+10] -(Open[i+10] - Close[i+10])/2))/((Open[i+6] -(Open[i+6] - Close[i+6])/2)-0.172744 
               *(Open[i+1] -(Open[i+1] - Close[i+1])/2))));
   
   for (i = LengthSample-1; i>=0; i--)
      {            
       XX[i] = Kn*NormalizeDouble((0.5*(0.6*(0.4*(0.409795 *(ZS[i+8] -(0.5*(Open[i+8] - Low[i+8])/2 - 0.5*(0.55*(High[i+8] - Low[i+8])/2 + 0.45*(Open[i+8] - Close[i+8])/2)))
               +0.20536 *(ZS[i+8] -(Open[i+9] - Close[i+9])/2)+0.384862 *(ZS[i+8] -(Open[i+8] - Close[i+8])/2))+0.6*ZS[i+5])+0.4*ZS[i]) 
               +0.5*(0.6*(0.5*(0.6*(0.480644 *(ZS[i+9] -(0.5*(Open[i] - Low[i])/2 - 0.5*(0.55*(High[i] - Low[i])/2 + 0.45*(Open[i] - Close[i])/2)))
               +0.23399 *(ZS[i+1] -(Open[i+1] - Close[i+1])/2)+0.37171 *(ZS[i+7] -(Open[i] - Close[i])/2)-0.0862743 *(ZS[i+11] 
               -(-0.55*(High[i+2] - Low[i+2])/2 - 0.45*(Open[i+2] - Close[i+2])/2)))+0.4*ZS[i])+0.5*(0.6*(0.4*(0.409795 *(ZS[i+8] -(0.5*(Open[i+8] 
               - Low[i+8])/2 - 0.5*(0.55*(High[i+8] - Low[i+8])/2 + 0.45*(Open[i+8] - Close[i+8])/2)))+0.20536 *(ZS[i+8] -(Open[i+9] 
               - Close[i+9])/2)+0.384862 *(ZS[i+8] -(Open[i+8] - Close[i+8])/2))+0.6*ZS[i+5])+0.4*ZS[i]))+0.4*((3*(0.667748 *(ZS[i+3] 
               -(0.5*(Open[i+3] - Low[i+3])/2 - 0.5*(0.55*(High[i+3] - Low[i+3])/2 + 0.45*(Open[i+2] - Close[i+2])/2)))+0.332262 *(ZS[i+3] 
               -(Open[i+2] - Close[i+2])/2))-ZS[i+9])/2)))/Kn,Digits);
   
   if (XX[i]>ZS[i])
      {
       XN[i] = Kn*NormalizeDouble((0.6*(ZS[i]+MathAbs(XX[i]-ZS[i]))+0.4*(ZS[i] -(0.5*(Open[i] - Low[i])/2 - 0.5*(0.55*(High[i] - Low[i])/2 
               + 0.45*(Open[i] - Close[i])/2))))/Kn,Digits);
       XM[i] = Kn*NormalizeDouble((ZS[i]-MathAbs(XX[i]-ZS[i]))/Kn,Digits);
      } 
   else if (XX[i]<ZS[i])
      {
       XN[i] = Kn*NormalizeDouble((0.6*(ZS[i]-MathAbs(XX[i]-ZS[i]))+0.4*(ZS[i] -(0.5*(Open[i] - Low[i])/2 - 0.5*(0.55*(High[i] - Low[i])/2 
               + 0.45*(Open[i] - Close[i])/2))))/Kn,Digits);
       XM[i] = Kn*NormalizeDouble((ZS[i]+MathAbs(XX[i]-ZS[i]))/Kn,Digits);
      } 
   else 
      {
       XN[i] =XN[i+1];
       XM[i] =XM[i+1]; 
      }     
    }
   for (i = LengthSample-1; i>=0; i--)
     { 
       ZX[i] = 0.4*ZS[i]+0.6*(0.7*ZS[i]+0.3*(-2.53497 *(XM[i] - ZS[i] - XN[i+1])+1.84198 *(XX[i] - XN[i] - ZS[i+1])+0.306345 *XM[i+4]+0.000968391)); 
       
       ZC[i] = 0.7*ZS[i]+0.3*(-3.21666 *(XX[i+3] - ZS[i+4] - XN[i+3])+2.31797 *(XX[i+3] - XN[i+3] - ZS[i+4])+0.492555 *XM[i+6]+0.391206 *(XX[i] 
               - XM[i] - ZS[i+3]));

       ZZ[i] = 0.6*(0.5*ZS[i]+0.5*((-2.1952 *(XX[i] - XM[i] - ZS[i+7])*(XX[i] - ZS[i+1] - XN[i])+1.64506 *(XX[i] - XM[i] - ZS[i+7])*(XX[i] - XN[i] 
               - ZS[i+1]))/((XX[i] - XM[i] - ZS[i+7])+0.449856 *XN[i+2])))+0.4*(0.5*ZS[i]+0.5*((-2.1952 *(XX[i] - XM[i] - ZS[i+7])*(XX[i] - ZS[i+1] 
               - XN[i])+1.64506 *(XX[i] - XM[i] - ZS[i+7])*(XX[i] - XN[i] - ZS[i+1]))/((XX[i] - XM[i+1] - ZS[i+8])+0.449856 *XM[i+1])));
  
    if (ZS[i]>ZC[i])
       ZV[i] = Kn*NormalizeDouble((ZZ[i]+2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);
   else if (ZC[i]<ZZ[i])
       ZV[i] = Kn*NormalizeDouble((ZZ[i]-2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);
   else 
       ZV[i] =ZV[i+1]; 
  
   if (ZS[i]<ZC[i])
       ZB[i] = Kn*NormalizeDouble((ZZ[i]-2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);
   else if (ZC[i]>ZZ[i])
       ZB[i] = Kn*NormalizeDouble((ZZ[i]+2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits); 
   else 
       ZB[i] =ZB[i+1];
     
        
    if (ZC[i]<ZS[i])
       ZA[i] = Kn*NormalizeDouble((ZZ[i]-2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);
   else if (ZZ[i]>ZC[i])
       ZA[i] = Kn*NormalizeDouble((ZZ[i]+2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);
   else 
       ZA[i] =ZA[i+1]; 
  
   if (ZC[i]>ZS[i])
       ZD[i] = Kn*NormalizeDouble((ZZ[i]+2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);
   else if (ZZ[i]<ZC[i])
       ZD[i] = Kn*NormalizeDouble((ZZ[i]-2*MathAbs(ZX[i]-ZS[i]))/Kn,Digits);  
   else 
       ZD[i] =ZD[i+1]; 
     }
   for (i = LengthSample-21; i>=0; i--)
      { 
       GR1[i]= ZA[i];
       GR2[i]= ZD[i];
    //   GR3[i]= ZZ[i];
       GR4[i]= ZV[i];
       GR5[i]= ZS[i];
       GR6[i]= ZB[i];
      }       
   return(0);
     }//1
//+------------------------------------------------------------------+